
// DrawCovarianceEllipsesDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DrawCovarianceEllipses.h"
#include "DrawCovarianceEllipsesDlg.h"

#include "MatrixAlgebra.h"
#include "CovarianceEllipse.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CDrawCovarianceEllipsesDlg dialog
CDrawCovarianceEllipsesDlg::CDrawCovarianceEllipsesDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDrawCovarianceEllipsesDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDrawCovarianceEllipsesDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CDrawCovarianceEllipsesDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// CDrawCovarianceEllipsesDlg message handlers

BOOL CDrawCovarianceEllipsesDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not sigma_xx dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to sigma_xx control
}

// If you add sigma_xx minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDrawCovarianceEllipsesDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CPaintDC dc(this); // device context for painting

		//double sigma_xx = 682;
		//double sigma_xy = 531;
		//double sigma_yy = 1292;

		double sigma_xx = 2500;
		double sigma_xy = 600;
		double sigma_yy = 800;

		dMatrix C(2,2);

		C(0,0) = sigma_xx;
		C(0,1) = C(1,0) = sigma_xy;
		C(1,1) = sigma_yy;

		DrawProbDistribution (dc, 100, 100, C);

		DrawParticles (dc, 100, 100, C);

		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDrawCovarianceEllipsesDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

